`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Quenne Electric
// Engineer: Andras Bognar
// 
// Create Date:    15:35:04 05/24/2007 
// Design Name: 
// Module Name:    winyo 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module winyo(REC, SEND, CLK, DIR, EN, WPORT, RESET, IOW, IOR, A, SELP, SELS, BALE, LED, _COMMAND,_STATE,_TOSEND);
    input REC;
    output SEND;
    input CLK;
    output DIR;
    output EN;
    inout [15:0] WPORT;
    output RESET;
    output IOW;
    output IOR;
    output [2:0] A;
    output SELP;
    output SELS;
    output BALE;
	 output LED;
	 //test
	 output [7:0]_COMMAND;
	 output [3:0]_STATE;
	 output [7:0]_TOSEND;
	 
	//internal connections
	wire sysclk;
	wire [7:0]command;
	wire rcvd;
	wire tr_inproc;
	//state registers
	reg [7:0]tosend=0;
	reg trmt=0;
	reg [3:0]state=0;
	reg [1:0]rcsh=0;
	//output registers
	reg dir=0;
	reg en=0;
	reg [15:0]wport=0;
	reg reset=0;
	reg iow=0;
	reg ior=0;
	reg [2:0]a=0;
	reg selp=0;
	reg sels=0;
	reg bale=0;

	//prescaler p1(CLK,sysclk);
	//test
	assign sysclk=CLK;
	
	receiver r1(REC,command,sysclk,rcvd);
	transmitter t1(sysclk,tosend,trmt,SEND,tr_inproc);
	
	//command interpreter
	always@(posedge sysclk)
		begin
		rcsh[0]<=rcvd;
		rcsh[1]<=rcsh[0];
		
		case(state)
		4'h0:
			begin
			if(rcsh==2'b01)
				case(command)
				8'h01:
					begin
					state<=4'h1;dir=0;en=1;
					end
				8'h02:
					begin
					state<=4'h2;dir=1;en=1;
					end
				8'h03:state<=4'h3;
				8'h04:state<=4'h4;
				8'h05:state<=4'h5;
				8'h06:state<=4'h6;
				8'h07:state<=4'h7;
				8'h08:state<=4'h8;
				8'h09:state<=4'h9;
				8'h0A:state<=4'hA;
				default:state<=4'h0;
				endcase
			end
		4'h1:
			begin
			if(!tr_inproc)
				begin
				tosend<=WPORT[15:8];
				trmt=1;
				state<=4'hB;
				end
			end
		4'hB:
			begin
			trmt=0;state<=4'hC;
			end
		4'hC:
			begin
			if(!tr_inproc)
				begin
				tosend<=WPORT[7:0];
				trmt=1;
				state<=4'hD;
				end
			end
		4'hD:
			begin
			trmt=0;state<=4'h0;			
			end
		4'h2:
			begin
			if(rcsh==2'b01)
				begin
				wport[15:8]<=command;
				state<=4'hE;
				end
			end
		4'hE:
			begin
			if(rcsh==2'b01)
				begin
				wport[7:0]<=command;
				state<=4'h0;
				end			
			end
		4'h3:
			begin
			en=0;state<=4'h0;
			end
		4'h4:
			begin
			if(rcsh==2'b01)
				begin
				reset<=command[0];
				state<=4'h0;
				end						
			end
		4'h5:
			begin
			if(rcsh==2'b01)
				begin
				iow<=command[0];
				state<=4'h0;
				end						
			end
		4'h6:
			begin
			if(rcsh==2'b01)
				begin
				ior<=command[0];
				state<=4'h0;
				end						
			end
		4'h7:
			begin
			if(rcsh==2'b01)
				begin
				a<=command[2:0];
				state<=4'h0;
				end						
			end
		4'h8:
			begin
			if(rcsh==2'b01)
				begin
				selp<=command[0];
				state<=4'h0;
				end						
			end
		4'h9:
			begin
			if(rcsh==2'b01)
				begin
				sels<=command[0];
				state<=4'h0;
				end						
			end
		4'hA:
			begin
			if(rcsh==2'b01)
				begin
				bale<=command[0];
				state<=4'h0;
				end						
			end
		default:state<=4'h0;
		endcase
		end
	
	assign DIR=dir;
	assign EN=!en;
	assign WPORT=(dir)?wport:16'bz;
	assign RESET=reset;
	assign IOW=iow;
	assign IOR=ior;
	assign A=a;
	assign SELP=selp;
	assign SELS=sels;
	assign BALE=bale;
	assign LED=!rcvd&&tr_inproc;
	//test
	assign _COMMAND=command;
	assign _STATE=state;
	assign _TOSEND=tosend;

endmodule
